image: openjdk:8-jdk-slim

variables:
  MAVEN_OPTS: "-Dhttps.protocols=TLSv1.2 -Dmaven.color=false -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true -Dmaven.repo.local=.m2/repository"
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true"



stages:
  - install
  - build
  - tests
  
dependencies:
  stage: install
  script:
    - ./mvnw $MAVEN_CLI_OPTS dependency:resolve
  cache:
    paths:
      - .m2/repository/
    key: "$CI_PIPELINE_ID"
    policy: push

before_script:
  - chmod +x mvnw

build:
  stage: build
  script:
    - ./mvnw $MAVEN_CLI_OPTS clean compile jib:build

unit:
  variables:
    SCOPE: $CI_JOB_NAME
  stage: tests
  script:
    - ./mvnw $MAVEN_CLI_OPTS test

e2e tests:
  variables:
    SCOPE: $CI_JOB_NAME
  stage: tests
  script:
    - ./mvnw $MAVEN_CLI_OPTS test
